#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <unistd.h>
#include "error.h"
#include "data.h"
#include "apufunktiot.h"

int VLKM=4; /* How many characters can differ in the word suffices? */
bitvector *vartaloitu;

/* Read words from file. Assumes that each row is one sentence or other */
/* desired collection of words. Adds words into words-table which gives */
/* indices to them and creates a sentence-word graph g, where g[i][j]=1, */
/* word with index j occurs on row i. g is implemented as a bit matrix. */
/* n=number of rows, k=number of different words. */ 
char **readWords(FILE *f,int *n,int *k,bitvector ***g){

  char *row; 
  int i,clkm,size,next,v;
  char **words; 
  int LLEN=10000;
  char *seur;

  if ((row=(char*)malloc(LLEN))==NULL) error(6);

  (*n)=nofrows(f); /* number of rows */
  (*k)=0;

 /* word table, initial size 1000 */
 if ((words=(char**)malloc(1000*sizeof(char*)))==NULL)
   error(6);
 size=1000; clkm=0; 

  /* create graph matrix, initial size size words */
 if ((*g=(bitvector**)malloc(size*sizeof(bitvector*)))==NULL)
      error(6);

 for (i=0; i<size; i++) {
    (*g)[i]=bv_alloc(*n);
    bv_clr((*g)[i],*n);
  }

    vartaloitu=bv_alloc(size);
    bv_clr(vartaloitu,size);

 /* read data */
 next=0;

 while (next<(*n)) {

   if (fgets(row, LLEN, f)==NULL)
     error(5);

   if ((seur=strtok(row," "))!=NULL){
     if (seur[strlen(seur)-1]=='\n')
       seur[strlen(seur)-1]='\0';

     if (strcmp(seur,"\0")==0){
       next++; /* empty row */
       continue;
     }
     
     /* first word */
     if ((v=etsi(seur,words,clkm))==-1){
       addWord(&words,&clkm,seur,&size,g,*n);
       v=clkm-1; 
     }
     /* insert to matr */
     bv_setbit((*g)[v],next); 
   }

   /* the rest */
   while ((seur=strtok(NULL," "))!=NULL){
     if (seur[strlen(seur)-1]=='\n')
       seur[strlen(seur)-1]='\0';
     if ((v=etsi(seur,words,clkm))==-1){
       addWord(&words,&clkm,seur,&size,g,*n);
       v=clkm-1; 
     }
     /* insert to matr */

     /*     printf("sana %d %s rivi %d (size=%d)\n",v,words[v],next+1,size);*/

     bv_setbit((*g)[v],next); 

   }
   next++;
 }
 
 free(row);
 (*k)=clkm;
 return words;
}

void addWord(char ***t,int *clkm,char *sana,int *size,bitvector ***g,int n){
  int len=strlen(sana)+1;

 /* onko tilaa? jos ei, kasvata */
    if ((*clkm)>=(*size)){
      *g=kasvataBmatr(*g,*size,n);
    vartaloitu=kasvataBvec(vartaloitu,*size);
    *t=kasvatataulua(*t,size);
  } 
  if (((*t)[*clkm]=(char*)malloc(len*sizeof(char)))==NULL)
    error(6);

  strcpy((*t)[*clkm],sana);
  (*clkm)++;
}

/* kasvattaa 2-kert. */
char **kasvatataulua(char **t,int *size){

  if ((t=(char**)realloc(t,2*(*size)*sizeof(char*)))==NULL) 
    error(6);
  (*size)*=2;
  return t;
}

/* Huom! ei muuta sizea */
bitvector **kasvataBmatr(bitvector **g,int size,int n){
 int i;

  if ((g=(bitvector**)realloc(g,2*size*sizeof(bitvector*)))==NULL)
      error(6);

 for (i=size; i<2*size; i++) {
    (g)[i]=bv_alloc(n);
    bv_clr((g)[i],n);
  }


  return g;
}

bitvector *kasvataBvec(bitvector *v,int size){
  v=bv_realloc(v,2*size); 
  return v;
}


int etsi1(char *seur,char **t,int clkm){
  int i;

  for (i=0;i<clkm;i++)
    if (strcasecmp(seur,t[i])==0)
      return i;
  return -1; /* ei loytynyt */
}

/* Here it is enough that the first characters match; the last VLKM */
/* characters can differ */
int etsi2(char *seur,char **t,int clkm){
  int i,len2;
  int len1=strlen(seur);
  int tutki=len1;

  for (i=0;i<clkm;i++){
    if (len1>=VLKM+2)
      tutki=len1-VLKM;
    else tutki=len1;
    len2=strlen(t[i]);
    if ((bv_tstbit(vartaloitu,i)==0)&&(len2>=VLKM+2)&&(len2>len1)){
      tutki=len2-VLKM;
    }
    if (strncasecmp(seur,t[i],tutki)==0){

      /*printf("%s ja %s matsaavat (tutki=%d,len1=%d,len2=%d)\n",seur,t[i],tutki,len1,len2);*/

      /* ei sama 
      if (strcasecmp(seur,t[i])!=0){ 
	t[i][tutki]='\0';  vain vartalo jaa 
	bv_setbit(vartaloitu,i);
	} */
      return i;
    }
  }
  return -1; /* ei loytynyt */
}


void printWords(bitvector **g,char **words,int n, int k){
  int i,j;

  for (i=0;i<n;i++){
    for (j=0;j<k;j++)
      if (bv_tstbit(g[j],i))
	printf("%s ",words[j]);
    /*printf("%d %s ",j,words[j]);*/
    printf("\n");
  }
}

