#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include <math.h>
#include "error.h"
#include "hits.h"

void hits(bitvector **g, int n, int k,float **Spainot,float **Vpainot,float MAXS, float MAXV,char **words){
  int i,j,laskuri=0;
  float *Sp, *Vp, *edSp, *edVp; /* sana- ja virkepainot */
  float ssum;

  /* Alustus */
  if ((Sp=(float*)malloc(k*sizeof(float)))==NULL) error(6);
  if ((edSp=(float*)malloc(k*sizeof(float)))==NULL) error(6);
  for (i=0;i<k;i++)
    Sp[i]=1.0/sqrtf((float)k);
  if ((Vp=(float*)malloc(n*sizeof(float)))==NULL) error(6);
  if ((edVp=(float*)malloc(n*sizeof(float)))==NULL) error(6);
  for (i=0;i<n;i++)
    Vp[i]=1.0/sqrtf((float)n);

  while ((laskuri<=1)||(konvergoi(edSp,Sp,edVp,Vp,n,k,MAXS,MAXV)!=1)){
    laskuri++; 
    /*printf("Kierros %d\n",laskuri);*/
    ssum=0.0;
    for (i=0;i<k;i++){ /* sanapainojen paivitys */
      edSp[i]=Sp[i]; Sp[i]=0.0;
      for (j=0;j<n;j++)
	if (bv_tstbit(g[i],j))
	  Sp[i]+=Vp[j];
      ssum+=Sp[i]*Sp[i];
    }
    for (i=0;i<k;i++)
      Sp[i]/=sqrt(ssum); /* normalisointi */
    
    ssum=0.0;
    for (i=0;i<n;i++){ /* virkepainojen paivitys */
      edVp[i]=Vp[i]; Vp[i]=0.0;
      for (j=0;j<k;j++)
	if (bv_tstbit(g[j],i))
	  Vp[i]+=edSp[j];
      ssum+=Vp[i]*Vp[i];
    }
    for (i=0;i<n;i++)
      Vp[i]/=sqrt(ssum); /* normalisointi */
  } /* while */


  *Spainot=Sp;    *Vpainot=Vp;  
  printf("Konvergoi %d kierroksen jalkeen\n",laskuri);
}


/* Jos yksikin paino poikkeaa edellisestä arvostaan merkittävästi, ei */
/* kovergoi. Merkittävä poikkeama: jos poikkeaman itseisarvo on */
/* suurempi kuin MAX. */
int konvergoi(float *edSp,float *Sp,float *edVp,float *Vp,int n,int k,float MAXS,float MAXV){
  int i;

  for (i=0;i<k;i++)
    if (fabsf(Sp[i]-edSp[i])>=MAXS)
      return 0;

  for (i=0;i<n;i++)
    if (fabsf(Vp[i]-edVp[i])>=MAXV)
      return 0;

  return 1;
}



void tulsanat(char **words, int k,float *Sp){
  int i;

  printf("Sanat ja painot:\n");
  for (i=0;i<k;i++)
    printf("[W=%.3f] %s\n",Sp[i],words[i]);

}

void tulvirk(char **words,int n,int k,float *Vp,bitvector **g,bitvector *vtmp){
  int i,j;

  printf("Rivit ja niiden sanat\n");


  for (i=0;i<n;i++)
    if (bv_tstbit(vtmp,i)){

      printf("[W=%.3f] virke %d: ",Vp[i],i+1);

      for (j=0;j<k;j++)
	if (bv_tstbit(g[j],i))
	  printf("%s ",words[j]);
      printf("\n");
    }

}

void printWeights(bitvector **g,char **words,int n, int k,float *Sp,float *Vp){
  int i,j;

  for (i=0;i<n;i++){
    printf("[Vpaino=%.3f] (rivi %d)",Vp[i],i+1);
    for (j=0;j<k;j++)
      if (bv_tstbit(g[j],i))
	printf(" %s(w=%.3f)",words[j],Sp[j]);
    /*printf(" %s(%d, w=%.3f)",words[j],j,Sp[j]);*/
    printf("\n");
  }
}
